---
title: ReportingObserver
slug: Web/API/ReportingObserver
tags:
  - API
  - Experimental
  - Interface
  - Reference
  - Reporting API
  - ReportingObserver
---
<div>{{seecompattable}}{{APIRef("Reporting API")}}</div>

<p class="summary">The <code>ReportingObserver</code> interface of the <a href="/en-US/docs/Web/API/Reporting_API">Reporting API</a> allows you to collect and access reports.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("ReportingObserver.ReportingObserver", "ReportingObserver()")}}</dt>
 <dd>Creates a new <code>ReportingObserver</code> object instance, which can be used to collect and access reports.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>This interface has no properties defined on it.</em></p>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("ReportingObserver.disconnect()")}}</dt>
 <dd>Stops a reporting observer that had previously started observing from collecting reports.</dd>
 <dt>{{domxref("ReportingObserver.observe()")}}</dt>
 <dd>Instructs a reporting observer to start collecting reports in its report queue.</dd>
 <dt>{{domxref("ReportingObserver.takeRecords()")}}</dt>
 <dd>Returns the current list of reports contained in the observer's report queue, and empties the queue.</dd>
</dl>

<h2 id="Events">Events</h2>

<p><em>This interface has no events that fire on it.</em></p>

<h2 id="Examples">Examples</h2>

<p>In our <a href="https://mdn.github.io/dom-examples/reporting-api/deprecation_report.html">deprecation_report.html</a> example, we create a simple reporting observer to observe usage of deprecated features on our web page:</p>

<pre class="brush: js">let options = {
  types: ['deprecation'],
  buffered: true
}

let observer = new ReportingObserver(function(reports, observer) {
  reportBtn.onclick = () =&gt; displayReports(reports);
}, options);</pre>

<p>We then tell it to start observing reports using {{domxref("ReportingObserver.observe()")}}; this tells the observer to start collecting reports in its report queue, and runs the callback function specified inside the constructor:</p>

<pre class="brush: js">observer.observe();</pre>

<p>Later on in the example we deliberately use the deprecated version of {{domxref("MediaDevices.getUserMedia()")}}:</p>

<pre class="brush: js">if(navigator.mozGetUserMedia) {
  navigator.mozGetUserMedia(
    constraints,
    success,
    failure);
} else {
  navigator.getUserMedia(
    constraints,
    success,
    failure);
}</pre>

<p>This causes a deprecation report to be generated; because of the event handler we set up inside the <code>ReportingObserver()</code> constructor, we can now click the button to display the report details.</p>

<p><img alt="image of a jolly bearded man with various stats displayed below it about a deprecated feature" src="https://mdn.mozillademos.org/files/16561/reporting_api_example.png" style="border-style: solid; border-width: 1px; display: block; height: 476px; margin: 0px auto; width: 902px;"></p>

<div class="notecard note">
<p><strong>Note</strong>: If you look at the <a href="https://github.com/mdn/dom-examples/blob/master/reporting-api/deprecation_report.html">complete source code</a>, you'll notice that we actually call the deprecated <code>getUserMedia()</code> method twice. After the first time we call {{domxref("ReportingObserver.takeRecords()")}}, which returns the first generated report and empties the queue. Because of this, when the button is pressed only the second report is listed.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Reporting API","#interface-reporting-observer","ReportingObserver")}}</td>
   <td>{{Spec2("Reporting API")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ReportingObserver")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Reporting_API">Reporting API</a></li>
</ul>
